#!/usr/bin/perl
##
#
# $Author: sbarn $
# $Revision: 1.2 $
# $Log: update_email.pl,v $
# Revision 1.2  2004-04-18 12:53:41-04  sbarn
# Initial Version
#
#
##
# update_email.pl
# Airline Operations Journal - maintain email address database
# Copyright 2004 D. Scott Barninger <barninger@fairfieldcomputers.com>
# Licensed under the GPL V2
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# version 1.0 18 Apr 2004

#-------------------------------------------------------------------#
# Program Configuration
#
# web server path to program from server root
my $prog_name = "/cgi-bin/update_email.pl";
# mysql database name
my $database = "database";
# mysql host
my $host = "localhost";
# mysql user
my $user = "dbuser";
# mysql password
my $password = "dbpassword";
# path to graphics from document root
my $logo_graphic = "/logo.gif";
my $spacer_graphic = "/clearpixel.gif";
# name and address information
my $airline_name = "My Airlines";
my $airline_address_1 = "Some International Airport";
my $airline_address_2 = "Anytown PA 20001";
my $copyright = "Copyright &copy; 2004 D. Scott Barninger";

#-------------------------------------------------------------------#

use DBI();

my %input = &getcgivars;
my $action = $input{'action'};
my $department = $input{'department'};
my $record = $input{'record'};
my $department_name;

&Main();
exit;

#-------------------------------------------------------------------#
# Function Main
# Description: check requested action and call appropriate subroutine
#
sub Main {
	# set default action & department
	if (!$action) {$action = "display"};
	if (!$department) {$department = "Ops"};
	if ($department eq "Ops") {$department_name = "Operations"};
	if ($department eq "Maint") {$department_name = "Maintenance"};

	if ($department ne "Ops" && $department ne "Maint") {
		&HTMLdie("Unknown department $department","So sorry Kimosabe..");
	}

	if ($action eq "display") {
		&Display();
	}
	elsif ($action eq "add") {
		&AddRecord();
	}
	elsif ($action eq "Delete") {
		&DeleteRecord();
	}
	elsif ($action eq "Edit") {
		&EditRecord();
	}
	else {
		&HTMLdie("Unknown action $action","So sorry Kimosabe..");
	}
	return;
}

#-------------------------------------------------------------------#
# Function Display
# Description: display email database

sub Display {

	&DisplayHeader("$airline_name $department_name Journal E-Mail List");
	print "<table width=\"80%\">";
	print "<tr>";
	print "<td>&nbsp;</td>";
	print "<td> Edit<br>Delete </td>";
	print "<td> Name </td>";
	print "<td> Address </td>";
	print "<td> Status </td>";
	print "</tr>";

	# connect to database
	my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host","$user","$password",
			{'RaiseError' => 1}) || &HTMLdie("Unable to connect to database.");
	# prepare query
	my $sth = $dbh->prepare("SELECT * FROM email 
		WHERE dept = \"$department\" 
		ORDER BY address");

	# retrieve data
	$sth->execute();
	while (my @data = $sth->fetchrow_array) {
		my $id = $data[4];
		my $status = $data[1];
		my ($status_1,$status_2);
		# now set value for alternate status for the dropdown list
		if ($status eq "Active") {
			$status_1 = "Active";
			$status_2 = "Inactive";
		}
		else {
			$status_1 = "Inactive";
			$status_2 = "Active";
		}
		print "<form action=$prog_name method=\"post\">";
		print "<input type=\"hidden\" name=\"id\" value=\"$data[4]\">";
		print "<input type=\"hidden\" name=\"department\" value=\"$department\">";
		print "<tr>";
		print "<td><input type=\"submit\" value=\"Post to $department_name List\"></td>";
		print "<td><select name=\"action\"><option>Edit</option><option>Delete</option></select></td>";
		print "<td><input type=\"text\" name=\"name\" value=\"$data[2]\" size=\"20\"></td>";
		print "<td><input type=\"text\" name=\"address\" value=\"$data[0]\" size=\"30\"></td>";
		print "<td><select name=\"status\"><option>$status_1</option><option>$status_2</option></select></td>";
		print "</tr>";
		print "</form>";
	}

	$sth->finish();
	$dbh->disconnect();

	print "</table>";
	&DisplayFooter;
}

#-------------------------------------------------------------------#
# Function DisplayHeader
# Description: display page header

sub DisplayHeader {
	my($title)= @_ ;
	$title || ($title= "$airline_name") ;
	print "Content-type: text/html\n\n";
	print "<html>";
	print "<head>";
	print "<title>$title</title>";
	print "</head>";
	print "<body>";
	print "<table>";
	print "<tbody>";
	print "<tr>";
	print "<td> <img src=\"$logo_graphic\"> </td>";
	print "<td> <img src=\"$spacer_graphic\" width=\"50\"> </td>";
	print "<td> <div align=\"center\"><h1><font color=\"#022A96\">$airline_name</font></h1>";
	print "<font color=\"#979797\">$airline_address_1<br>$airline_address_2</font>";
	print "</div> </td>";
	print "</tr>";
	print "</tbody>";
	print "</table>";  
	print "<div align=\"center\">";
	print "<h2>$title</h2>";
	print "<form action=$prog_name method=\"post\">";
	print "<input type=\"hidden\" name=\"action\" value=\"add\">";
	print "<input type=\"hidden\" name=\"department\" value=\"$department\">";
	print "<table width=\"80%\">";
	print "<tbody>";
	print "<tr>";
	print "<td align=\"center\"> Name:&nbsp;<input type=\"text\" name=\"name\" size=\"40\"> </td>";
	print "<td align=\"center\"> E-Mail address:&nbsp;<input type=\"text\" name=\"address\" size=\"30\"> </td>";
	print "</tr>";
	print "<tr>";
	print "<td colspan = \"2\" align=\"center\"> <input type=\"submit\" value=\"Add to $department_name List\"> </td>";
	print "</tr>";
	print "</tbody>";
	print "</table>";
	print "</form>";
	print "<p></p>";
	return;
}

#-------------------------------------------------------------------#
# Function DisplayFooter
# Description: display page footer

sub DisplayFooter {
	print "<table width=\"100%\">";
	print "<tbody>";
	print "<tr>";
	print "<td><div align=\"center\"><font size=\"-3\"> $copyright </font></div></td>";
	print "</tbody>";
	print "</table>";
	print "</div>";
	print "</body>";
	print "</html>";
	return;
}

#-------------------------------------------------------------------#
# Function AddRecord
# Description: add a new address

sub AddRecord {
	my $department = $input{'department'};
	my $name = $input{'name'};
	my $address = $input{'address'};

	# connect to database
	my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host","$user","$password",
			{'RaiseError' => 1}) || &HTMLdie("Unable to connect to database.");
	# prepare query
	my $sth = $dbh->prepare("
		INSERT INTO email SET 
		address = \"$address\", type = \"Active\", name = \"$name\", dept = \"$department\"");
	$sth->execute();
	$sth->finish();
	$dbh->disconnect();

	&Display();
}

#-------------------------------------------------------------------#
# Function EditRecord
# Description: edit an address

sub EditRecord {
	my $id = $input{'id'};
	my $name = $input{'name'};
	my $address = $input{'address'};
	my $status = $input{'status'};

	# connect to database
	my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host","$user","$password",
			{'RaiseError' => 1}) || &HTMLdie("Unable to connect to database.");
	# prepare query
	my $sth = $dbh->prepare("UPDATE email 
		SET name = \"$name\", address = \"$address\", type = \"$status\" 
		WHERE id = $id");

	$sth->execute();
	$sth->finish();
	$dbh->disconnect();

	&Display();
}

#-------------------------------------------------------------------#
# Function DeleteRecord
# Description: delete an address

sub DeleteRecord {
	my $id = $input{'id'};

	# connect to database
	my $dbh = DBI->connect("DBI:mysql:database=$database;host=$host","$user","$password",
			{'RaiseError' => 1}) || &HTMLdie("Unable to connect to database.");
	# prepare query
	my $sth = $dbh->prepare("DELETE FROM email WHERE id = $id");

	$sth->execute();
	$sth->finish();
	$dbh->disconnect();

	&Display();
}

#-------------------------------------------------------------------#
# Function getcgivars
# Read all CGI vars into an associative array.
# courtesy James Marshall james@jmarshall.com http://www.jmarshall.com/easy/cgi/
# If multiple input fields have the same name, they are concatenated into
#   one array element and delimited with the \0 character (which fails if
	#   the input has any \0 characters, very unlikely but conceivably possible).
# Currently only supports Content-Type of application/x-www-form-urlencoded.
sub getcgivars {
	local($in, %in) ;
	local($name, $value) ;


		# First, read entire string of CGI vars into $in
	if ( ($ENV{'REQUEST_METHOD'} eq 'GET') ||
			($ENV{'REQUEST_METHOD'} eq 'HEAD') ) {
		$in= $ENV{'QUERY_STRING'} ;

	} elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
		if ($ENV{'CONTENT_TYPE'}=~ m#^application/x-www-form-urlencoded$#i) {
			length($ENV{'CONTENT_LENGTH'})
				|| &HTMLdie("No Content-Length sent with the POST request.") ;
			read(STDIN, $in, $ENV{'CONTENT_LENGTH'}) ;

		} else { 
			&HTMLdie("Unsupported Content-Type: $ENV{'CONTENT_TYPE'}") ;
		}

	} else {
		&HTMLdie("Script was called with unsupported REQUEST_METHOD.") ;
	}

		# Resolve and unencode name/value pairs into %in
	foreach (split('&', $in)) {
		s/\+/ /g ;
		($name, $value)= split('=', $_, 2) ;
		$name=~ s/%(..)/chr(hex($1))/ge ;
		$value=~ s/%(..)/chr(hex($1))/ge ;
		$in{$name}.= "\0" if defined($in{$name}) ;  # concatenate multiple vars
		$in{$name}.= $value ;
	}

	return %in ;

}

#-------------------------------------------------------------------#
# Function HTMLdie
# Description: Die, outputting HTML error page
# If no $title, use a default title
sub HTMLdie {
	local($msg,$title)= @_ ;
	$title || ($title= "CGI Error") ;
	print "Content-type: text/html\n\n";
	print "<html>";
	print "<head>";
	print "<title>$title</title>";
	print "</head>";
	print "<body>";
	print "<h1>$title</h1>";
	print "<h3>$msg</h3>";
	print "<form>";
	print "<input type=button name=\"BackButton\" value=\"<- Back\" id=\"Button1\" onClick=\"history.back()\">";
	print "</form>";
	print "</body>";
	print "</html>";

	exit ;
}
